import java.rmi.*;
import java.rmi.server.*;

class BankAccount extends ReplicableRemote implements Account
{
	public String name;
	public Integer no;
	public Integer balance;

	public BankAccount() throws RemoteException{
		name = new String();
	}
	
	public BankAccount(String name, int no, int balance) throws RemoteException{
		this.name = new String(name);
		this.no = new Integer(no);
		this.balance = new Integer(balance);
	}

	public String getAccountName() throws RemoteException {
		System.out.println("Name is " + name);
		return name;
	}

	public void setBalance(int value) throws RemoteException {
		set(new Integer(value));
	}

	public int getBalance() throws RemoteException {
		return ((Integer)get()).intValue();
	}

	public static void main(String[] args) 
	{
		/** 
		 * Get the server & port info from the command line.
		 * Or use the InetAddress class to get local host address
		 */
		String serverPort = args[0]; 

		try{
		  System.out.println("Constructing server implementation ...");

		  /**
		   * You can initialise the BankAccount object accordingly
		   */
		  BankAccount acc1 = new BankAccount("Nauzad", 1234, 1000);
		  System.out.println("Binding server Implementations to registry ....");
		  Naming.rebind(serverPort+"Account",acc1);
		  System.out.println("Waiting for invocations from clients ...");

		  acc1.setStateVariable("balance");

		  System.out.println("State Variable Set");
		}
		catch (Exception e){
		  System.out.println("Error: "+e);
		}
	}
}